﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1
{
    public class TGauss
    {

        void SwitchRows(int n)
        {
            TComplex tempD;
            int i, j;
            for (i = n; i <= maxOrder - 2; i++)
            {
                for (j = 0; j <= maxOrder - 1; j++)
                {
                    tempD = m.a[i, j];
                    m.a[i, j] = m.a[i + 1, j];
                    m.a[i + 1, j] = tempD;
                }
                tempD = m.y[i];
                m.y[i] = m.y[i + 1];
                m.y[i + 1] = tempD;
            }
        }


        public int maxOrder = 4;
        TMatrix m;

        public TGauss(int size, TMatrix mi)
        {
            maxOrder = size;
            m = mi;
        }

        public bool Eliminate()
        {
            int i, k, l;
            bool calcError = false;
            i = 1;

            for (k = 0; k <= maxOrder - 2; k++)
            {
                l = k + 1;
                while ((MathComp.Abs(m.a[k, k]) < 1e-8) && (l < maxOrder))
                {
                    SwitchRows(k);
                    l++;
                }
                if (l < maxOrder)
                {
                    for (i = k; i <= maxOrder - 2; i++)
                    {
                        if (!calcError)
                        {
                            if (MathComp.Abs(m.a[i + 1, k]) > 1e-8)
                            {
                                for (l = k + 1; l <= maxOrder - 1; l++)
                                {
                                    m.a[i + 1, l] = MathComp.Diff(MathComp.Prod(m.a[i + 1, l], m.a[k, k]), MathComp.Prod(m.a[k, l], m.a[i + 1, k]));
                                }
                                m.y[i + 1] = MathComp.Diff(MathComp.Prod(m.y[i + 1], m.a[k, k]), MathComp.Prod(m.y[k], m.a[i + 1, k]));
                                m.a[i + 1, k].real = 0.0;
                                m.a[i + 1, k].imag = 0.0;
                            }

                        }
                    }
                }
                else
                    calcError = true;
            }
            return !calcError;
        }

        public void Solve()
        {
            int k, l;
            m.x[maxOrder - 1].real = 1.0;
            m.x[maxOrder - 1].imag = 0.0;
            for (k = maxOrder - 2; k >= 0; k--)
            {
                for (l = maxOrder - 1; l >= k; l--)
                {
                    m.y[k] = MathComp.Diff(m.y[k], MathComp.Prod(m.x[l], m.a[k, l]));
                }
                m.x[k] = MathComp.Quot(m.y[k], m.a[k, k]);
            }
        }
    }

}
